## dragonegg 3.3

=== Makefile ===
# Specify the gcc executable you will use the dragonegg plugin with either here
# or on the command line, for example like this (replace gcc-4.7 with the gcc
# you want to load the plugin into):
#   GCC=gcc-4.7 make ...
# If you don't specify anything, then by default the plugin targets the compiler
# used to build it.
GCC?=$(CC)

# Specify the copy of LLVM you will build the plugin against by giving its
# llvm-config here or on the command line.  To use an installed copy of LLVM,
# specify the installed llvm-config (just 'llvm-config' is enough if it is in
# your path).  It is not necessary to install LLVM to build dragonegg against
# it.  Instead you can do an LLVM build and point LLVM_CONFIG to the copy of
# llvm-config that was created during the build.
LLVM_CONFIG?=llvm-config

# Location of this Makefile, useful if you want separate source and object
# directories.
TOP_DIR?=$(CURDIR)

# Normally the plugin will refuse to load into a different gcc to the one it was
# built against.  Uncomment this (or pass DISABLE_VERSION_CHECK=1 on the 'make'
# command line) to disable the check.
#DISABLE_VERSION_CHECK=1

# Where to find the lit.py script and modules, used for running tests.
LIT_DIR?=$(shell $(LLVM_CONFIG) --src-root)/utils/lit
# Where to find LLVM utils, used for running tests.
LLVM_TOOLS_DIR?=$(shell $(LLVM_CONFIG) --obj-root)/bin:$(shell $(LLVM_CONFIG) \
	--obj-root)/$(shell $(LLVM_CONFIG) --build-mode)/bin/

INCLUDE_DIR=$(TOP_DIR)/include
SRC_DIR=$(TOP_DIR)/src

ifndef VERBOSE
QUIET:=@
endif

COMMON_FLAGS=-Wall -Wextra
ifdef ENABLE_LLVM_PLUGINS
COMMON_FLAGS+=-DENABLE_LLVM_PLUGINS
else
COMMON_FLAGS+=-fvisibility=hidden
endif
CFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cflags)
CXXFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cxxflags)

ifeq ($(shell uname),Darwin)
LOADABLE_MODULE_OPTIONS=-bundle -undefined dynamic_lookup
else
LOADABLE_MODULE_OPTIONS=-shared -Wl,-O1
ifndef ENABLE_LLVM_PLUGINS
LOADABLE_MODULE_OPTIONS+=-Wl,--version-script=$(TOP_DIR)/exports.map
endif
endif

GCC_PLUGIN_DIR=$(shell $(GCC) -print-file-name=plugin)
GCC_VERSION=$(shell $(GCC) -dumpversion).0
GCC_MAJOR=$(word 1, $(subst ., ,$(GCC_VERSION)))
GCC_MINOR=$(word 2, $(subst ., ,$(GCC_VERSION)))
GCC_MICRO=$(word 3, $(subst ., ,$(GCC_VERSION)))
TARGET_TRIPLE=$(shell $(GCC) -dumpmachine)

LLVM_VERSION=$(shell $(LLVM_CONFIG) --version)

PLUGIN=dragonegg.so
PLUGIN_OBJECTS=Aliasing.o Backend.o Cache.o ConstantConversion.o Convert.o \
	       Debug.o DefaultABI.o Trees.o TypeConversion.o bits_and_bobs.o

TARGET_OBJECT=Target.o
TARGET_SOURCE=$(SRC_DIR)/$(shell $(TARGET_UTIL) -p)/Target.cpp

TARGET_UTIL_OBJECTS=TargetInfo.o
TARGET_UTIL=./TargetInfo

ALL_OBJECTS=$(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL_OBJECTS)

CPP_OPTIONS+=$(CPPFLAGS) $(shell $(LLVM_CONFIG) --cppflags) \
	     -fno-rtti \
	     -MD -MP \
	     -DIN_GCC -DLLVM_VERSION=\"$(LLVM_VERSION)\" \
	     -DTARGET_TRIPLE=\"$(TARGET_TRIPLE)\" \
	     -DGCC_MAJOR=$(GCC_MAJOR) -DGCC_MINOR=$(GCC_MINOR) \
	     -DGCC_MICRO=$(GCC_MICRO) \
	     -I$(INCLUDE_DIR) -isystem$(GCC_PLUGIN_DIR)/include
ifdef DISABLE_VERSION_CHECK
CPP_OPTIONS+=-DDISABLE_VERSION_CHECK
endif
ifneq ($(GCC_MINOR), 5)
  ifneq ($(GCC_MINOR), 6)
    ifneq ($(GCC_MINOR), 7)
      # gcc-4.8 and later are always built with C++.
      CPP_OPTIONS+=-DENABLE_BUILD_WITH_CXX
    endif
  endif
endif

LD_OPTIONS+=$(shell $(LLVM_CONFIG) --ldflags) $(LDFLAGS)

LLVM_COMPONENTS=ipo scalaropts target
ifdef ENABLE_LLVM_PLUGINS
# The same components as the "opt" tool.
LLVM_COMPONENTS+=bitreader bitwriter asmparser instrumentation vectorize
endif

# NOTE: The following flags can only be used after TARGET_UTIL has been built.
TARGET_HEADERS+=-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -p) \
		-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -o)

ifdef VERBOSE
LIT_ARGS+=-v
else
LIT_ARGS+=-s -v
endif

LIT_SITE_CONFIG=test/dragonegg-lit.site.cfg
TEST_SRC_DIR=$(TOP_DIR)/test
PYPATH=$(TEST_SRC_DIR):$(LIT_DIR)/lit:$(PYTHONPATH)

default: gcc-sane llvm-config-sane $(PLUGIN)

.PHONY: gcc-sane
gcc-sane:
	$(QUIET)$(GCC) --version > /dev/null

.PHONY: llvm-config-sane
llvm-config-sane:
	$(QUIET)$(LLVM_CONFIG) --version > /dev/null

$(TARGET_UTIL_OBJECTS): %.o : $(TOP_DIR)/utils/%.cpp
	@echo Compiling utils/$*.cpp
	$(QUIET)$(CXX) -c \
	$(CPP_OPTIONS) $(CXXFLAGS) $<

$(TARGET_UTIL): $(TARGET_UTIL_OBJECTS)
	@echo Linking $@
	$(QUIET)$(CXX) -o $@ $^ $(shell $(LLVM_CONFIG) --libs support) \
	$(LD_OPTIONS)

%.o : $(SRC_DIR)/%.cpp $(TARGET_UTIL)
	@echo Compiling $*.cpp
	$(QUIET)$(CXX) -c $(TARGET_HEADERS) $(CPP_OPTIONS) $(CXXFLAGS) $<

$(TARGET_OBJECT): $(TARGET_UTIL)
	@echo Compiling $(shell $(TARGET_UTIL) -p)/Target.cpp
	$(QUIET)$(CXX) -o $@ -c $(TARGET_HEADERS) $(CPP_OPTIONS) $(CXXFLAGS) \
	$(TARGET_SOURCE)

$(PLUGIN): $(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL)
	@echo Linking $@
	$(QUIET)$(CXX) -o $@ $(LOADABLE_MODULE_OPTIONS) $(CXXFLAGS) \
	$(PLUGIN_OBJECTS) $(TARGET_OBJECT) \
	$(shell $(LLVM_CONFIG) --libs $(LLVM_COMPONENTS) \
	$(shell $(TARGET_UTIL) -p)) \
	$(LD_OPTIONS)

$(LIT_SITE_CONFIG): $(TEST_SRC_DIR)/dragonegg-lit.site.cfg.in
	@echo "Making DragonEgg '$@' file..."
	$(QUIET)mkdir -p test
	$(QUIET)echo s=@DRAGONEGG_PLUGIN@=$(CURDIR)/$(PLUGIN)=g > lit.tmp
	$(QUIET)echo s=@GCC@=$(GCC)=g >> lit.tmp
	$(QUIET)echo s=@LLVM_TOOLS_DIR@=$(LLVM_TOOLS_DIR)=g >> lit.tmp
	$(QUIET)echo s=@TARGET_TRIPLE@=$(TARGET_TRIPLE)-gcc-$(GCC_MAJOR).$(GCC_MINOR)=g >> lit.tmp
	$(QUIET)echo s=@TEST_OUTPUT_DIR@=$(CURDIR)/test/Output=g >> lit.tmp
	$(QUIET)sed -f lit.tmp $< > $@
	$(QUIET)-rm -f lit.tmp

.PHONY: check-compilator
check-compilator: $(PLUGIN) $(LIT_SITE_CONFIG)
	@echo "Running test suite 'compilator'"
	$(QUIET)PYTHONPATH=$(PYPATH) $(LIT_DIR)/lit.py $(LIT_ARGS) --param site="$(LIT_SITE_CONFIG)" \
	--config-prefix=compilator-lit $(TEST_SRC_DIR)/compilator

.PHONY: check-validator
check-validator: $(PLUGIN) $(LIT_SITE_CONFIG)
	@echo "Running test suite 'validator'"
	$(QUIET)PYTHONPATH=$(PYPATH) $(LIT_DIR)/lit.py $(LIT_ARGS) --param site="$(LIT_SITE_CONFIG)" \
	--config-prefix=validator-lit $(TEST_SRC_DIR)/validator

.PHONY: check
check: check-validator check-compilator

.PHONY: clean
clean:
	$(QUIET)rm -f *.o *.d $(PLUGIN) $(TARGET_UTIL) $(LIT_SITE_CONFIG)

.DELETE_ON_ERROR:


-include $(ALL_OBJECTS:.o=.d)

# The following target exists for the benefit of the dragonegg maintainers, and
# is not used in a normal build.  You need to specify the path to the GCC build
# directory in GCC_BUILD_DIR.
GENGTYPE_INPUT=$(SRC_DIR)/Cache.cpp
GENGTYPE_OUTPUT=$(INCLUDE_DIR)/dragonegg/gt-cache-$(GCC_MAJOR).$(GCC_MINOR).inc
.PHONY: gt-cache.inc
gt-cache.inc:
	$(QUIET)$(GCC_BUILD_DIR)/gcc/build/gengtype \
	-r $(GCC_BUILD_DIR)/gcc/gtype.state \
	-P $(GENGTYPE_OUTPUT) $(GENGTYPE_INPUT)
	$(QUIET)sed -i "s/__.*gt/__gt/" $(GENGTYPE_OUTPUT)
	$(QUIET)sed -i "s/_$(GCC_MAJOR)_$(GCC_MINOR)_/_/" $(GENGTYPE_OUTPUT)

=== debian/changelog ===
dragonegg (3.3-2) unstable; urgency=low

  * Fix FTBFS under arm. Thanks to Dan Chen (Closes: #715424)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 27 Nov 2013 22:33:48 +0100

dragonegg (3.3-1) unstable; urgency=low

  * Upload to unstable (Closes: #686231)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 07 Jul 2013 15:21:34 +0200

dragonegg (3.3-1~exp1) experimental; urgency=low

  * New upstream release
  * get ride of the support of 4.6 and provide 4.8
  * Enable hardening flags also to the linker
  * dragonegg: empty-binary-package fixed (dependency package)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 11 Jun 2013 14:44:21 +0200

dragonegg (3.2-1) unstable; urgency=low

  * Upload to unstable
  * Standards-Version updated to 3.9.4

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 09 May 2013 22:22:36 +0200

dragonegg (3.2-1~exp2) experimental; urgency=low

  [ Matthias Klose ]
  * Remove subversion from the build-depends (Closes: #700070)
  * Link with the shared llvm library (Closes: #700071)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 08 Feb 2013 09:11:44 +0100

=== debian/control ===
Source: dragonegg
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Robert Millan <rmh.debian@aybabtu.com>, Sylvestre Ledru <sylvestre@debian.org>
Build-Depends:
 cdbs,
 dpkg-dev (>= 1.16.1~),
 debhelper (>= 7),
 gcc-4.7-plugin-dev (>= 4.7.2-10),
 gcc-4.8-plugin-dev,
 g++-4.7 (>= 4.7.2-10),
 g++-4.8,
 llvm-3.3-dev (>= 3.3),
 libffi-dev,
 libmpfr-dev,
 libmpc-dev
Standards-Version: 3.9.4
Homepage: http://dragonegg.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/dragonegg/trunk/

Package: dragonegg
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg-4.7
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.
 .
 This package is a dependency package.

Package: dragonegg-4.7
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc-4.7 | g++-4.7
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: dragonegg-4.8
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc-4.8 | g++-4.8
Replaces: dragonegg (<< 3.3)
Breaks: dragonegg (<< 3.3)
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.8 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: llvm-gcc-4.7
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg-4.7, gcc-4.7, g++-4.7
Replaces: llvm-gcc-4.6
Breaks: llvm-gcc-4.6
Description: C front end for LLVM C/C++ compiler
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs.
 .
 This is the DragonEgg-based version of llvm-gcc.

Package: llvm-gcc-4.8
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg-4.8, gcc-4.8, g++-4.8
Provides: llvm-gcc
Conflicts: llvm-gcc, llvm-gcc-4.5
Replaces: llvm-gcc-4.5
Description: C front end for LLVM C/C++ compiler
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs.
 .
 This is the DragonEgg-based version of llvm-gcc.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

LLVM_VERSION = 3.3
GCC_VERSION = 4.7
GCC_VERSION_NEXT = 4.8


deb_version		:= $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
upstream_version	:= $(shell echo $(deb_version) | sed -e "s/-[^-]*$$//")
major 			:= $(shell echo $(upstream_version) | sed -e "s/\([0-9]\+\.[0-9]\+\)[\.-].*/\1/g")

plugindir := $(shell gcc-$(GCC_VERSION) -print-file-name=plugin)
plugindir_NEXT := $(shell gcc-$(GCC_VERSION_NEXT) -print-file-name=plugin)

include /usr/share/cdbs/1/rules/debhelper.mk

stamps/build:
# link with llvm
	mkdir -p $(DEB_SRCDIR)/$(GCC_VERSION)
	cd $(DEB_SRCDIR)/$(GCC_VERSION); \
	GCC=gcc-$(GCC_VERSION) CC=gcc-$(GCC_VERSION) CXX=g++-$(GCC_VERSION) \
	DISABLE_VERSION_CHECK=1 LDFLAGS="-L/usr/lib/llvm-$(LLVM_VERSION)/lib $(LDFLAGS)" \
	$(MAKE) \
		VERBOSE=1 \
		LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config \
		-C ../; \
	mv ../dragonegg.so .

	make LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config clean

	mkdir -p $(DEB_SRCDIR)/$(GCC_VERSION_NEXT)
	cd $(DEB_SRCDIR)/$(GCC_VERSION_NEXT); \
	GCC=gcc-$(GCC_VERSION_NEXT) CC=gcc-$(GCC_VERSION_NEXT) CXX=g++-$(GCC_VERSION_NEXT) \
	DISABLE_VERSION_CHECK=1 LDFLAGS="-L/usr/lib/llvm-$(LLVM_VERSION)/lib $(LDFLAGS)"  \
	$(MAKE) \
		VERBOSE=1 \
		LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config \
		-C ..; \
	mv ../dragonegg.so .
	mkdir -p stamps
	touch $@


stamps/install:
	mkdir -p debian/dragonegg-$(GCC_VERSION)/$(plugindir)
	install -m755 $(DEB_SRCDIR)/$(GCC_VERSION)/dragonegg.so debian/dragonegg-$(GCC_VERSION)/$(plugindir)/
	mkdir -p debian/dragonegg-$(GCC_VERSION_NEXT)/$(plugindir_NEXT)
	install -m755 $(DEB_SRCDIR)/$(GCC_VERSION_NEXT)/dragonegg.so debian/dragonegg-$(GCC_VERSION_NEXT)/$(plugindir_NEXT)/
	mkdir -p stamps
	touch $@

stamps/install-llvm-gcc-$(GCC_VERSION):
	mkdir -p debian/llvm-gcc-$(GCC_VERSION)/usr/bin
	sed -e 's,@plugindir@,$(plugindir),' -e 's,@GCC_VERSION@,$(GCC_VERSION),' debian/gcc-wrap.in > debian/gcc-wrap
	for i in cpp g++ gcc gccbug gcov ; do \
		install -m755 debian/gcc-wrap debian/llvm-gcc-$(GCC_VERSION)/usr/bin/llvm-$$i ; \
	done
	# Do the same for c++ as gcc but without the version (not provided by
	# gcc-defaults)
	sed -e 's,@plugindir@,$(plugindir),' -e 's,@GCC_VERSION@,$(GCC_VERSION),' debian/c++-wrap.in > debian/c++-wrap

stamps/install-llvm-gcc-$(GCC_VERSION_NEXT):
	mkdir -p debian/llvm-gcc-$(GCC_VERSION_NEXT)/usr/bin
	sed -e 's,@plugindir@,$(plugindir_NEXT),' -e 's,@GCC_VERSION@,$(GCC_VERSION_NEXT),'  debian/gcc-wrap-next.in > debian/gcc-wrap
	for i in cpp g++ gcc gccbug gcov ; do \
		install -m755 debian/gcc-wrap debian/llvm-gcc-$(GCC_VERSION_NEXT)/usr/bin/llvm-$$i-$(GCC_VERSION_NEXT) ; \
	done
	# Do the same for c++ as gcc but without the version (not provided by
	# gcc-defaults)
	sed -e 's,@plugindir@,$(plugindir_NEXT),' -e 's,@GCC_VERSION@,$(GCC_VERSION_NEXT),' debian/c++-wrap.in > debian/c++-wrap

build/dragonegg-$(GCC_VERSION):: stamps/build
install/dragonegg-$(GCC_VERSION):: stamps/install

install/llvm-gcc-$(GCC_VERSION):: stamps/install-llvm-gcc-$(GCC_VERSION)

install/llvm-gcc-$(GCC_VERSION_NEXT):: stamps/install-llvm-gcc-$(GCC_VERSION_NEXT)

clean::
	rm -rf $(GCC_VERSION)  $(GCC_VERSION_NEXT)
	$(MAKE) clean VERBOSE=1 LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config
	rm -f debian/gcc-wrap
	rm -rf stamps

=== debian/watch ===
version=3
opts=uversionmangle=s/\.(tar.*|tgz|zip|gz|bz2)$//i,dversionmangle=s/[-.+~]?(cvs|svn|git|snapshot|pre|hg)(.*)$//i,pasv \
http://llvm.org/releases/download.html (?:.*/)?dragonegg-?_?([\d+\.]+|\d+)\.src.(tar.*|tgz|zip|gz|bz2|) debian

## dragonegg 3.4

=== debian/changelog ===
dragonegg (3.4-2) unstable; urgency=medium

  * Upgrade was failing (override file) (Closes: #752851)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 02 Jul 2014 09:46:12 +0200

dragonegg (3.4-1) unstable; urgency=medium

  * New upstream version (Closes: #747030)
  * Only support a single version of gcc
  * Get ride of gcc 4.7 to provide 4.8 (Closes: #751302)
  * Fix the FTBFS (Closes: #735754)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 22 Jun 2014 16:35:33 -0700

dragonegg (3.4~rc2-1~exp1) experimental; urgency=low

  * New testing version
  * Switch to LLVM 3.4
  * Standards-Version updated to 3.9.5

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 03 Dec 2013 09:53:58 +0100

=== debian/control ===
Source: dragonegg
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Robert Millan <rmh.debian@aybabtu.com>, Sylvestre Ledru <sylvestre@debian.org>
Build-Depends:
 cdbs,
 dpkg-dev (>= 1.16.1~),
 debhelper (>= 7),
 gcc-4.8-plugin-dev,
 g++-4.8,
 llvm-3.4-dev (>= 3.4),
 libffi-dev,
 libmpfr-dev,
 libmpc-dev
Standards-Version: 3.9.5
Homepage: http://dragonegg.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/dragonegg/trunk/

Package: dragonegg
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc-4.8 | g++-4.8
Breaks: dragonegg-4.8 (<< 3.4-1)
Replaces: dragonegg-4.8 (<< 3.4-1)
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: llvm-gcc
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg, gcc-4.8, g++-4.8
Provides: llvm-gcc
Conflicts: llvm-gcc, llvm-gcc-4.5
Replaces: llvm-gcc-4.5
Description: C front end for LLVM C/C++ compiler
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs.
 .
 This is the DragonEgg-based version of llvm-gcc.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

LLVM_VERSION = 3.4
GCC_VERSION = 4.8


deb_version		:= $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
upstream_version	:= $(shell echo $(deb_version) | sed -e "s/-[^-]*$$//")
major 			:= $(shell echo $(upstream_version) | sed -e "s/\([0-9]\+\.[0-9]\+\)[\.-].*/\1/g")

plugindir := $(shell gcc-$(GCC_VERSION) -print-file-name=plugin)

include /usr/share/cdbs/1/rules/debhelper.mk

stamps/build:
	mkdir stamps
# link with llvm
	mkdir -p $(DEB_SRCDIR)/$(GCC_VERSION)
	cd $(DEB_SRCDIR)/$(GCC_VERSION); \
	GCC=gcc-$(GCC_VERSION) CC=gcc-$(GCC_VERSION) CXX=g++-$(GCC_VERSION) \
	DISABLE_VERSION_CHECK=1 LDFLAGS="-L/usr/lib/llvm-$(LLVM_VERSION)/lib $(LDFLAGS)" \
	$(MAKE) \
		VERBOSE=1 \
		LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config \
		-C ../; \
	mv ../dragonegg.so .

	touch $@


stamps/install:
	mkdir -p debian/dragonegg/$(plugindir)/
	install -m755 $(DEB_SRCDIR)/$(GCC_VERSION)/dragonegg.so debian/dragonegg/$(plugindir)/
	mkdir -p stamps
	touch $@

stamps/install-llvm-gcc:
	mkdir -p debian/llvm-gcc/usr/bin
	sed -e 's,@plugindir@,$(plugindir),' -e 's,@GCC_VERSION@,$(GCC_VERSION),' debian/gcc-wrap.in > debian/gcc-wrap
	for i in cpp g++ gcc gccbug gcov ; do \
		install -m755 debian/gcc-wrap debian/llvm-gcc/usr/bin/llvm-$$i ; \
	done
	# Do the same for c++ as gcc but without the version (not provided by
	# gcc-defaults)
	sed -e 's,@plugindir@,$(plugindir),' -e 's,@GCC_VERSION@,$(GCC_VERSION),' debian/c++-wrap.in > debian/c++-wrap


build/dragonegg:: stamps/build
install/dragonegg:: stamps/install

install/llvm-gcc:: stamps/install-llvm-gcc

clean::
	rm -rf $(GCC_VERSION)
	$(MAKE) clean VERBOSE=1 LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config
	rm -f debian/gcc-wrap
	rm -rf stamps

=== debian/watch ===
version=3
opts=uversionmangle=s/\.(tar.*|tgz|zip|gz|bz2)$//i,dversionmangle=s/[-.+~]?(cvs|svn|git|snapshot|pre|hg)(.*)$//i,pasv \
http://llvm.org/releases/download.html (?:.*/)?dragonegg-?_?([\d+\.]+|\d+)\.src.(tar.*|tgz|zip|gz|bz2|) debian
